Subject: Re: "du -b --files0-from=-" running out of memory
From: Jim Meyering <[email-masked]>
To: Pádraig Brady <[email-masked]>
Cc: Eric Blake <[email-masked]>, [email-masked], bug-coreutils <[email-masked]>
Date: Tue, 25 Nov 2008 17:56:22 +0100
List-Id: <cygwin.cygwin.com>

Pádraig Brady <[email-masked]> wrote:
> Jim Meyering wrote:
>> Subject: [PATCH 1/2] argv-iter: new module
>>
>> * gl/lib/argv-iter.h: New file.
>> * gl/lib/argv-iter.c: New file.
>> * gl/modules/argv-iter: New file.
>
> Very useful module!
>
> I see that --files0-from was added to `du` in Mar 2004,
> so it's a nice solution to this 4 year old issue.

Thanks.
I'm surprised it took so long to bite.

> I notice that argv_iter does a malloc() + memcpy() per entry.
> Since the sources are already NUL terminated strings
> perhaps it could just return a pointer to a getdelim
> realloc'd buffer which was referenced in the argv_iterator struct.

The only per-entry allocation I see is:
  - in argv-mode: strdup
  - in stream-reading mode: getdelim

Did I miss something?

char *
argv_iter (struct argv_iterator *ai, enum argv_iter_err *err)
{
  if (ai->fp)
    {
      char *name = NULL;
      size_t buf_len = 0;
      ssize_t len = getdelim (&name, &buf_len, '\0', ai->fp);
      if (len < 0)
        {
          free (name);
          *err = feof (ai->fp) ? AI_ERR_EOF : AI_ERR_READ;
          return NULL;
        }

      *err = AI_ERR_OK;
      ai->item_idx++;
      return name;
    }
  else
    {
      if (*(ai->p) == NULL)
        {
          *err = AI_ERR_EOF;
          return NULL;
        }
      else
        {
          *err = AI_ERR_OK;
          return strdup (*(ai->p++));
        }
    }
}

--
Unsubscribe info:      http://cygwin.com/ml/#unsubscribe-simple
Problem reports:       http://cygwin.com/problems.html
Documentation:         http://cygwin.com/docs.html
FAQ:                   http://cygwin.com/faq/